<?php

                // The BOOKMARKSDB one page navigator		//
                // permission is granted to use modified copies //
		// of this program on condition that this	//
		// original copyright notice remains intact.	//
                //                                              //
		// Copyright 2001 Antonio Bonifati		//
		// <antonio.b@infinito.it>			//
		// <kiss@clubnautilus.net>			//
		//						//
                // distributed under GPL (see COPYING)          //

########## cgi arguments
# parent          id of the directory to list
#		(normally not used - defaults to 0)
# withfile	pass it if you want to show normal files
#		otherwise only directories will be listed
#		(empty argument)
##########

// include the common function library
require 'admin/lib.php';

?>
<html>
<head><title>BookmarksDB: all in one page</title></head>
<body bgcolor="#ffffff">
<h1 align="center">BookmarksDB - all</h1>
<hr noshade size=1>
<?php

// try to connect to the MySQL database server
// using permanent connection
try_mysql_pconnect();

// try to open db DBNAME
try_mysql_selectdb();

if (!isset($parent))
   $parent=0;	// starts from root for default

// print entire tree recursively
$reclevel=-1;
print_tree();

function print_tree()
{
   global $parent, $withfile, $reclevel;

   $reclevel++;

   $qid=do_listing_query((!isset($withfile)) ? ("AND type='D'") : (''));

   //// print bookmark directory

   if (!mysql_num_rows($qid))
   {
      if (isset($withfile) && EMPTYMARK)
      {
	 do_indent();
	 echo EMPTYMARK, ENDMARK, "\n";
      }
   }
   else
      while ($row=mysql_fetch_array($qid, MYSQL_ASSOC))
	 if ($row['type']=='D')	// directory
	 {
	    do_indent();

	    printf(DIRMARK, '', $row['id'], htmlspecialchars($row['name']));
	    if ($row['comment'])
	       printf(COMMENTMARK, strip_tags($row['comment']));
	    echo ENDMARK . "\n";

	    $parent=$row['id'];
	    print_tree();
	 }
	 else			// file
	 {
	    do_indent();

	    printf(URLMARK,
		protocol_name($row['type']) .'://'. $row['url'], htmlspecialchars($row['name']));
	    if ($row['comment'])
		printf(COMMENTMARK, strip_tags($row['comment']));
	    echo ENDMARK . "\n";
	 }

   $reclevel--;
   mysql_freeresult($qid);
}

?>
<hr noshade size=1>
<font size=-2><a href="./">Root index</a> |
<a href="search.php">Search</a> |
<?php if (isset($withfile)): ?>
<a href="all.php">Expand only directories</a>
<?php else: ?>
<a href="all.php?withfile=">Expand all</a>
<?php endif; ?></font>
<h6 align="center">Copyright 2001
<a href="mailto:antonio.b@infinito.it">Antonio Bonifati</a>.
Distributed under <a href="COPYING">GPL</a>.</h6>
</body>
</html>
